/*
 * Copyright (C) 2012-2013 Apple Inc. All rights reserved.
 *
 * This document is the property of Apple Inc.
 * It is considered confidential and proprietary.
 *
 * This document may not be reproduced or transmitted in any form,
 * in whole or in part, without the express written permission of
 * Apple Inc.
 */


/* THIS STRUCT IS AUTOMATICALLY GENERATED BY tools/csvtopinconfig.py. DO NOT EDIT!
   I/O Spreadsheet version: rev 1.10
   I/O Spreadsheet tracker: <rdar://problem/12012942> J72 IO Spreadsheet
*/

/* Different drive strength for AP and DEV. */
#if PIN_CFG_AP
#define AP_DEV_DRIVE_STR(ap, dev) DRIVE_##ap
#elif PIN_CFG_DEV
#define AP_DEV_DRIVE_STR(ap, dev) DRIVE_##dev
#endif

#ifdef SUB_TARGET_J71
#if PIN_CFG_AP
static const u_int32_t gpio_default_cfg_ap[GPIO_GROUP_COUNT * GPIOPADPINS] = {
#elif PIN_CFG_DEV
static const u_int32_t gpio_default_cfg_dev[GPIO_GROUP_COUNT * GPIOPADPINS] = {
#endif

/* Port  0 */
	CFG_DISABLED,						//   0 : TST_CLKOUT		-> SOC_TST_CLKOUT
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//   1 : WDOG			-> WDOG_SOC
	CFG_IN,							//   2 : GPIO[0]		-> GPIO_BTN_HOME_L
	CFG_IN,							//   3 : GPIO[1]		-> GPIO_BTN_ONOFF_L
	CFG_IN | PULL_UP,					//   4 : GPIO[2]		-> GPIO_BTN_VOL_DOWN_L
	CFG_IN | PULL_UP,					//   5 : GPIO[3]		-> GPIO_BTN_VOL_UP_L
	CFG_IN | PULL_UP,					//   6 : GPIO[4]		-> GPIO_CAM_ALS2SOC_IRQ_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//   7 : GPIO[5]		-> GPIO_BT_WAKE

/* Port  1 */
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			//   8 : GPIO[6]		-> GPIO_SOC2BB_WAKE_MODEM
	CFG_DISABLED,						//   9 : GPIO[7]		-> NC_GPIO7
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			//  10 : GPIO[8]		-> GPIO_SOC2BB_RST_L
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			//  11 : GPIO[9]		-> GPIO_SOC2BB_RADIO_ON_L
	CFG_DISABLED | PULL_DOWN,				//  12 : GPIO[10]		-> GPIO_BB2SOC_RESET_DET_L
	CFG_DISABLED,						//  13 : GPIO[11]		-> NC_GPIO11
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  14 : GPIO[12]		-> GPIO_SOC2OSCAR_DBGEN
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  15 : GPIO[13]		-> GPIO_SOC2GRAPE_RESET_L

/* Port  2 */
	CFG_DISABLED,						//  16 : GPIO[14]		-> NC_GPIO14
	CFG_DISABLED,						//  17 : GPIO[15]		-> GPIO_BB2SOC_GSM_TXBURST
	CFG_DISABLED,						//  18 : GPIO[16]		-> GPIO_BOARD_ID_3
	CFG_IN,							//  19 : GPIO[17]		-> GPIO_TS2SOC2PMU_INT
	CFG_DISABLED,						//  20 : GPIO[18]		-> GPIO_BOOT_CONFIG_0
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			//  21 : GPIO[19]		-> GPIO_BB2SOC_GPS_SYNC
	CFG_IN,							//  22 : GPIO[20]		-> GPIO_PROX2SOC_IRQ_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  23 : GPIO[21]		-> GPIO_SOC2LCD_PWREN

/* Port  3 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  4 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  32 : UART1_TXD		-> UART1_SOC2BT_TX
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  33 : UART1_RXD		-> UART1_BT2SOC_TX
	CFG_OUT_1 | DRIVE_X2 | SLOW_SLEW,			//  34 : UART1_RTSN		-> UART1_SOC2BT_RTS_L
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  35 : UART1_CTSN		-> UART1_BT2SOC_RTS_L
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  36 : UART2_TXD		-> UART2_SOC2WLAN_TX
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  37 : UART2_RXD		-> UART2_WLAN2SOC_TX
	CFG_DISABLED,						//  38 : UART2_RTSN		-> NC_GPIO_UART2_RTSN
	CFG_DISABLED,						//  39 : UART2_CTSN		-> NC_GPIO_UART2_CTSN

/* Port  5 */
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			//  40 : UART3_TXD		-> UART3_SOC2BB_TX
	CFG_DISABLED | SLOW_SLEW,				//  41 : UART3_RXD		-> UART3_BB2SOC_TX
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			//  42 : UART3_RTSN		-> UART3_SOC2BB_RTS_L
	CFG_DISABLED | SLOW_SLEW,				//  43 : UART3_CTSN		-> UART3_BB2SOC_RTS_L
	CFG_FUNC0 | AP_DEV_DRIVE_STR(X1, X2) | SLOW_SLEW,	//  44 : UART5_RTXD		-> UART5_BATT_TRXD
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  6 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  7 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  8 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  64 : UART4_TXD		-> UART4_SOC2OSCAR_TXD
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  65 : UART4_RXD		-> UART4_OSCAR2SOC_RXD
	CFG_OUT_1 | DRIVE_X2 | SLOW_SLEW,			//  66 : UART4_RTSN		-> GPIO_OSCAR_RESET_L
	CFG_IN,							//  67 : UART4_CTSN		-> PMU_GPIO_OSCAR2PMU_HOST_WAKE
	CFG_DISABLED,						//  68 : SPI1_SCLK		-> NC_SPI1_SCLK
	CFG_DISABLED,						//  69 : SPI1_MOSI		-> NC_SPI1_MOSI
	CFG_DISABLED,						//  70 : SPI1_MISO		-> NC_SPI1_MISO
	CFG_DISABLED,						//  71 : SPI1_SSIN		-> NC_SPI1_SSIN

/* Port  9 */
	CFG_DISABLED,						//  72 : SPI0_SCLK		-> GPIO_BOARD_ID_0
	CFG_DISABLED,						//  73 : SPI0_MOSI		-> GPIO_BOARD_ID_1
	CFG_DISABLED,						//  74 : SPI0_MISO		-> GPIO_BOARD_ID_2
	CFG_DISABLED,						//  75 : SPI0_SSIN		-> NC_SPI0_SSIN
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  76 : SPI2_SCLK		-> SPI2_GRAPE_SCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  77 : SPI2_MOSI		-> SPI2_GRAPE_MOSI
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  78 : SPI2_MISO		-> SPI2_GRAPE_MISO
	CFG_OUT_1 | AP_DEV_DRIVE_STR(X1, X2) | SLOW_SLEW,	//  79 : SPI2_SSIN		-> SPI2_GRAPE_CS_L

/* Port 10 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  80 : I2C0_SDA		-> I2C0_SDA_1V8
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  81 : I2C0_SCL		-> I2C0_SCL_1V8
	CFG_DISABLED,						//  82 : I2C1_SDA		-> I2C1_SOC2OSCAR_SWDIO_1V8
	CFG_DISABLED,						//  83 : I2C1_SCL		-> I2C1_SOC2OSCAR_SWDCLK_1V8
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  84 : ISP0_SDA		-> ISP0_CAM_REAR_SDA
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  85 : ISP0_SCL		-> ISP0_CAM_REAR_SCL
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  86 : ISP1_SDA		-> ISP1_CAM_FRONT_SDA
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  87 : ISP1_SCL		-> ISP1_CAM_FRONT_SCL

/* Port 11 */
	CFG_OUT_0 | PULL_DOWN | DRIVE_X2 | SLOW_SLEW,		//  88 : SENSOR0_RST		-> ISP0_CAM_REAR_SHUTDOWN_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  89 : SENSOR0_CLK		-> ISP0_CAM_REAR_CLK_R
	CFG_DISABLED,						//  90 : SENSOR0_XSHUTDOWN	-> NC_SENSOR0_XSHUTDOWN
	CFG_DISABLED,						//  91 : SENSOR0_ISTRB		-> BB_IPC_GPIO
	CFG_OUT_0 | PULL_DOWN | DRIVE_X2 | SLOW_SLEW,		//  92 : SENSOR1_RST		-> ISP1_CAM_FRONT_SHUTDOWN_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  93 : SENSOR1_CLK		-> ISP1_CAM_FRONT_CLK_R
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  94 : SENSOR1_XSHUTDOWN	-> AUD_SPKRAMP_MUTE_L
	CFG_DISABLED,						//  95 : SENSOR1_ISTRB		-> NC_SENSOR1_ISTRB

/* Port 12 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  96 : SPI3_MOSI		-> SPI3_CODEC_MOSI
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  97 : SPI3_MISO		-> SPI3_CODEC_MISO
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  98 : SPI3_SCLK		-> SPI3_CODEC_SCLK
	CFG_OUT_1 | DRIVE_X2 | SLOW_SLEW,			//  99 : SPI3_SSIN		-> SPI3_CODEC_CS_L
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 100 : I2C2_SDA		-> I2C2_SDA_1V8
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 101 : I2C2_SCL		-> I2C2_SCL_1V8
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 102 : GPIO[22]		-> GPIO_SOC2PMU_KEEPACT
	CFG_IN | PULL_UP,					// 103 : GPIO[23]		-> GPIO_PMU2SOC_IRQ_L

/* Port 13 */
	CFG_IN | PULL_UP,					// 104 : GPIO[24]		-> GPIO_CODEC2SOC_IRQ_L
	CFG_DISABLED,						// 105 : GPIO[25]		-> GPIO_BOOT_CONFIG_1
	CFG_IN,							// 106 : GPIO[26]		-> GPIO_FORCE_DFU
	CFG_OUT_0 | SLOW_SLEW,					// 107 : GPIO[27]		-> TP_GPIO_DFU_STATUS
	CFG_DISABLED,						// 108 : GPIO[28]		-> GPIO_BOOT_CONFIG_2
	CFG_DISABLED,						// 109 : GPIO[29]		-> GPIO_BOOT_CONFIG_3
	CFG_IN,							// 110 : GPIO[30]		-> GPIO_BTN_SRL_L
	CFG_IN | PULL_UP,					// 111 : GPIO[31]		-> GPIO_GRAPE2SOC_IRQ_L

/* Port 14 */
	CFG_DISABLED,						// 112 : GPIO[32]		-> NC_GPIO32
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 113 : GPIO[33]		-> GPIO_HS3_SHUNT_EN
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 114 : GPIO[34]		-> GPIO_HS4_SHUNT_EN
	CFG_DISABLED,						// 115 : GPIO[35]		-> GPIO_BRD_REV3
	CFG_DISABLED,						// 116 : GPIO[36]		-> GPIO_BRD_REV2
	CFG_DISABLED,						// 117 : GPIO[37]		-> GPIO_BRD_REV1
	CFG_DISABLED,						// 118 : GPIO[38]		-> GPIO_BRD_REV0
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 119 : DISP_VSYNC		-> DISPLAY_SYNC

/* Port 15 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 120 : SOCHOT0		-> SOCHOT0_L
	CFG_FUNC0 | DRIVE_X2,					// 121 : SOCHOT1		-> SOCHOT1_L
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 122 : UART0_TXD		-> UART0_SOC_TXD
	CFG_FUNC0 | PULL_UP | SLOW_SLEW,			// 123 : UART0_RXD		-> UART0_SOC_RXD
	CFG_FUNC0 | SLOW_SLEW,					// 124 : DWI_DI			-> SOC_TST_CPUSWITCH_OUT
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 125 : DWI_DO			-> DWI_AP_DO
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 126 : DWI_CLK		-> DWI_AP_CLK
	CFG_DISABLED,						// 127 : UNSPECIFIED		-> UNSPECIFIED

/* Port 16 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 128 : I2S0_LRCK		-> I2S0_CODEC_ASP_LRCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 129 : I2S0_BCLK		-> I2S0_CODEC_ASP_BCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 130 : I2S0_DOUT		-> I2S0_CODEC_ASP_DOUT
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 131 : I2S0_DIN		-> I2S0_CODEC_ASP_DIN
	CFG_DISABLED,						// 132 : I2S1_MCK		-> NC_I2S1_MCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 133 : I2S1_LRCK		-> I2S1_CODEC_XSP_LRCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 134 : I2S1_BCLK		-> I2S1_CODEC_XSP_BCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 135 : I2S1_DOUT		-> I2S1_CODEC_XSP_DOUT

/* Port 17 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 136 : I2S1_DIN		-> I2S1_CODEC_XSP_DIN
	CFG_DISABLED,						// 137 : I2S2_LRCK		-> NC_I2S2_LRCK
	CFG_DISABLED,						// 138 : I2S2_BCLK		-> NC_I2S2_BCLK
	CFG_DISABLED,						// 139 : I2S2_DOUT		-> NC_I2S2_DOUT
	CFG_DISABLED,						// 140 : I2S2_DIN		-> NC_I2S2_DIN
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 141 : I2S3_MCK		-> BB_JTAG_TRST_L
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 142 : I2S3_LRCK		-> BB_JTAG_TDO
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 143 : I2S3_BCLK		-> BB_JTAG_TDI

/* Port 18 */
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 144 : I2S3_DOUT		-> BB_JTAG_TMS
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 145 : I2S3_DIN		-> BB_JTAG_TCK
	CFG_DISABLED,						// 146 : I2S4_MCK		-> NC_I2S4_MCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 147 : I2S4_LRCK		-> I2S4_SOC2BT_LRCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 148 : I2S4_BCLK		-> I2S4_SOC2BT_BCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 149 : I2S4_DOUT		-> I2S4_SOC2BT_DATA
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 150 : I2S4_DIN		-> I2S4_BT2SOC_DATA
	CFG_DISABLED,

/* Port 19 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 20 */
	CFG_OUT_0 | SLOW_SLEW,					// 160 : TMR32_PWM0		-> OSCAR_TIME_SYNC_HOST_INT
	CFG_DISABLED,						// 161 : TMR32_PWM1		-> NC_TMR32_PWM1
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 162 : TMR32_PWM2		-> CLK_32K_SOC2CUMULUS
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 163 : SIO_7816UART0_SDA	-> HSIC1_SOC2WLAN_HOST_RDY
	CFG_IN,							// 164 : SIO_7816UART0_SCL	-> HSIC1_WLAN2SOC_DEVICE_RDY
	CFG_IN | PULL_DOWN,					// 165 : SIO_7816UART0_RST	-> HSIC1_WLAN2SOC_REMOTE_WAKE
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 166 : SIO_7816UART1_SDA	-> HSIC2_SOC2BB_HOST_RDY
	CFG_DISABLED | PULL_DOWN,				// 167 : SIO_7816UART1_SCL	-> HSIC2_BB2SOC_DEVICE_RDY

/* Port 21 */
	CFG_DISABLED | PULL_DOWN,				// 168 : SIO_7816UART1_RST	-> HSIC2_BB2SOC_REMOTE_WAKE
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 169 : UART6_TXD		-> UART6_TS_ACC_TXD
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 170 : UART6_RXD		-> UART6_TS_ACC_RXD
	CFG_FUNC0 | FAST_SLEW,					// 171 : I2C3_SDA		-> I2C3_SDA_1V8
	CFG_FUNC0 | FAST_SLEW,					// 172 : I2C3_SCL		-> I2C3_SCL_1V8
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 22 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 23 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 24 */
	CFG_FUNC0 | SLOW_SLEW,					// 192 : EDP_HPD		-> EDP_HPD
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 193 : I2S0_MCK		-> I2S0_CODEC_ASP_MCK
	CFG_DISABLED,						// 194 : I2S2_MCK		-> NC_I2S2_MCK
};
#endif /* SUB_TARGET_J71 */

#ifdef SUB_TARGET_J72
#if PIN_CFG_AP
static const u_int32_t gpio_default_cfg_ap[GPIO_GROUP_COUNT * GPIOPADPINS] = {
#elif PIN_CFG_DEV
static const u_int32_t gpio_default_cfg_dev[GPIO_GROUP_COUNT * GPIOPADPINS] = {
#endif

/* Port  0 */
	CFG_DISABLED,						//   0 : TST_CLKOUT		-> SOC_TST_CLKOUT
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//   1 : WDOG			-> WDOG_SOC
	CFG_IN,							//   2 : GPIO[0]		-> GPIO_BTN_HOME_L
	CFG_IN,							//   3 : GPIO[1]		-> GPIO_BTN_ONOFF_L
	CFG_IN | PULL_UP,					//   4 : GPIO[2]		-> GPIO_BTN_VOL_DOWN_L
	CFG_IN | PULL_UP,					//   5 : GPIO[3]		-> GPIO_BTN_VOL_UP_L
	CFG_IN | PULL_UP,					//   6 : GPIO[4]		-> GPIO_CAM_ALS2SOC_IRQ_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//   7 : GPIO[5]		-> GPIO_BT_WAKE

/* Port  1 */
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//   8 : GPIO[6]		-> GPIO_SOC2BB_WAKE_MODEM
	CFG_DISABLED,						//   9 : GPIO[7]		-> NC_GPIO7
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  10 : GPIO[8]		-> GPIO_SOC2BB_RST_L
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  11 : GPIO[9]		-> GPIO_SOC2BB_RADIO_ON_L
	CFG_IN | PULL_DOWN,					//  12 : GPIO[10]		-> GPIO_BB2SOC_RESET_DET_L
	CFG_DISABLED,						//  13 : GPIO[11]		-> NC_GPIO11
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  14 : GPIO[12]		-> GPIO_SOC2OSCAR_DBGEN
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  15 : GPIO[13]		-> GPIO_SOC2GRAPE_RESET_L

/* Port  2 */
	CFG_DISABLED,						//  16 : GPIO[14]		-> NC_GPIO14
	CFG_IN,							//  17 : GPIO[15]		-> GPIO_BB2SOC_GSM_TXBURST
	CFG_DISABLED,						//  18 : GPIO[16]		-> GPIO_BOARD_ID_3
	CFG_IN,							//  19 : GPIO[17]		-> GPIO_TS2SOC2PMU_INT
	CFG_DISABLED,						//  20 : GPIO[18]		-> GPIO_BOOT_CONFIG_0
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  21 : GPIO[19]		-> GPIO_BB2SOC_GPS_SYNC
	CFG_IN,							//  22 : GPIO[20]		-> GPIO_PROX2SOC_IRQ_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  23 : GPIO[21]		-> GPIO_SOC2LCD_PWREN

/* Port  3 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  4 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  32 : UART1_TXD		-> UART1_SOC2BT_TX
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  33 : UART1_RXD		-> UART1_BT2SOC_TX
	CFG_OUT_1 | DRIVE_X2 | SLOW_SLEW,			//  34 : UART1_RTSN		-> UART1_SOC2BT_RTS_L
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  35 : UART1_CTSN		-> UART1_BT2SOC_RTS_L
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  36 : UART2_TXD		-> UART2_SOC2WLAN_TX
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  37 : UART2_RXD		-> UART2_WLAN2SOC_TX
	CFG_DISABLED,						//  38 : UART2_RTSN		-> NC_GPIO_UART2_RTSN
	CFG_DISABLED,						//  39 : UART2_CTSN		-> NC_GPIO_UART2_CTSN

/* Port  5 */
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  40 : UART3_TXD		-> UART3_SOC2BB_TX
	CFG_FUNC0 | SLOW_SLEW,					//  41 : UART3_RXD		-> UART3_BB2SOC_TX
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  42 : UART3_RTSN		-> UART3_SOC2BB_RTS_L
	CFG_FUNC0 | SLOW_SLEW,					//  43 : UART3_CTSN		-> UART3_BB2SOC_RTS_L
	CFG_FUNC0 | AP_DEV_DRIVE_STR(X1, X2) | SLOW_SLEW,	//  44 : UART5_RTXD		-> UART5_BATT_TRXD
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  6 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  7 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  8 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  64 : UART4_TXD		-> UART4_SOC2OSCAR_TXD
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  65 : UART4_RXD		-> UART4_OSCAR2SOC_RXD
	CFG_OUT_1 | DRIVE_X2 | SLOW_SLEW,			//  66 : UART4_RTSN		-> GPIO_OSCAR_RESET_L
	CFG_IN,							//  67 : UART4_CTSN		-> PMU_GPIO_OSCAR2PMU_HOST_WAKE
	CFG_DISABLED,						//  68 : SPI1_SCLK		-> NC_SPI1_SCLK
	CFG_DISABLED,						//  69 : SPI1_MOSI		-> NC_SPI1_MOSI
	CFG_DISABLED,						//  70 : SPI1_MISO		-> NC_SPI1_MISO
	CFG_DISABLED,						//  71 : SPI1_SSIN		-> NC_SPI1_SSIN

/* Port  9 */
	CFG_DISABLED,						//  72 : SPI0_SCLK		-> GPIO_BOARD_ID_0
	CFG_DISABLED,						//  73 : SPI0_MOSI		-> GPIO_BOARD_ID_1
	CFG_DISABLED,						//  74 : SPI0_MISO		-> GPIO_BOARD_ID_2
	CFG_DISABLED,						//  75 : SPI0_SSIN		-> NC_SPI0_SSIN
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  76 : SPI2_SCLK		-> SPI2_GRAPE_SCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  77 : SPI2_MOSI		-> SPI2_GRAPE_MOSI
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  78 : SPI2_MISO		-> SPI2_GRAPE_MISO
	CFG_OUT_1 | AP_DEV_DRIVE_STR(X1, X2) | SLOW_SLEW,	//  79 : SPI2_SSIN		-> SPI2_GRAPE_CS_L

/* Port 10 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  80 : I2C0_SDA		-> I2C0_SDA_1V8
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  81 : I2C0_SCL		-> I2C0_SCL_1V8
	CFG_DISABLED,						//  82 : I2C1_SDA		-> I2C1_SOC2OSCAR_SWDIO_1V8
	CFG_DISABLED,						//  83 : I2C1_SCL		-> I2C1_SOC2OSCAR_SWDCLK_1V8
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  84 : ISP0_SDA		-> ISP0_CAM_REAR_SDA
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  85 : ISP0_SCL		-> ISP0_CAM_REAR_SCL
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  86 : ISP1_SDA		-> ISP1_CAM_FRONT_SDA
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  87 : ISP1_SCL		-> ISP1_CAM_FRONT_SCL

/* Port 11 */
	CFG_OUT_0 | PULL_DOWN | DRIVE_X2 | SLOW_SLEW,		//  88 : SENSOR0_RST		-> ISP0_CAM_REAR_SHUTDOWN_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  89 : SENSOR0_CLK		-> ISP0_CAM_REAR_CLK_R
	CFG_DISABLED,						//  90 : SENSOR0_XSHUTDOWN	-> NC_SENSOR0_XSHUTDOWN
	CFG_DISABLED,						//  91 : SENSOR0_ISTRB		-> BB_IPC_GPIO
	CFG_OUT_0 | PULL_DOWN | DRIVE_X2 | SLOW_SLEW,		//  92 : SENSOR1_RST		-> ISP1_CAM_FRONT_SHUTDOWN_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  93 : SENSOR1_CLK		-> ISP1_CAM_FRONT_CLK_R
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  94 : SENSOR1_XSHUTDOWN	-> AUD_SPKRAMP_MUTE_L
	CFG_DISABLED,						//  95 : SENSOR1_ISTRB		-> NC_SENSOR1_ISTRB

/* Port 12 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  96 : SPI3_MOSI		-> SPI3_CODEC_MOSI
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  97 : SPI3_MISO		-> SPI3_CODEC_MISO
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  98 : SPI3_SCLK		-> SPI3_CODEC_SCLK
	CFG_OUT_1 | DRIVE_X2 | SLOW_SLEW,			//  99 : SPI3_SSIN		-> SPI3_CODEC_CS_L
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 100 : I2C2_SDA		-> I2C2_SDA_1V8
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 101 : I2C2_SCL		-> I2C2_SCL_1V8
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 102 : GPIO[22]		-> GPIO_SOC2PMU_KEEPACT
	CFG_IN | PULL_UP,					// 103 : GPIO[23]		-> GPIO_PMU2SOC_IRQ_L

/* Port 13 */
	CFG_IN | PULL_UP,					// 104 : GPIO[24]		-> GPIO_CODEC2SOC_IRQ_L
	CFG_DISABLED,						// 105 : GPIO[25]		-> GPIO_BOOT_CONFIG_1
	CFG_IN,							// 106 : GPIO[26]		-> GPIO_FORCE_DFU
	CFG_OUT_0 | SLOW_SLEW,					// 107 : GPIO[27]		-> TP_GPIO_DFU_STATUS
	CFG_DISABLED,						// 108 : GPIO[28]		-> GPIO_BOOT_CONFIG_2
	CFG_DISABLED,						// 109 : GPIO[29]		-> GPIO_BOOT_CONFIG_3
	CFG_IN,							// 110 : GPIO[30]		-> GPIO_BTN_SRL_L
	CFG_IN | PULL_UP,					// 111 : GPIO[31]		-> GPIO_GRAPE2SOC_IRQ_L

/* Port 14 */
	CFG_DISABLED,						// 112 : GPIO[32]		-> NC_GPIO32
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 113 : GPIO[33]		-> GPIO_HS3_SHUNT_EN
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 114 : GPIO[34]		-> GPIO_HS4_SHUNT_EN
	CFG_DISABLED,						// 115 : GPIO[35]		-> GPIO_BRD_REV3
	CFG_DISABLED,						// 116 : GPIO[36]		-> GPIO_BRD_REV2
	CFG_DISABLED,						// 117 : GPIO[37]		-> GPIO_BRD_REV1
	CFG_DISABLED,						// 118 : GPIO[38]		-> GPIO_BRD_REV0
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 119 : DISP_VSYNC		-> DISPLAY_SYNC

/* Port 15 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 120 : SOCHOT0		-> SOCHOT0_L
	CFG_FUNC0 | DRIVE_X2,					// 121 : SOCHOT1		-> SOCHOT1_L
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 122 : UART0_TXD		-> UART0_SOC_TXD
	CFG_FUNC0 | PULL_UP | SLOW_SLEW,			// 123 : UART0_RXD		-> UART0_SOC_RXD
	CFG_FUNC0 | SLOW_SLEW,					// 124 : DWI_DI			-> SOC_TST_CPUSWITCH_OUT
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 125 : DWI_DO			-> DWI_AP_DO
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 126 : DWI_CLK		-> DWI_AP_CLK
	CFG_DISABLED,						// 127 : UNSPECIFIED		-> UNSPECIFIED

/* Port 16 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 128 : I2S0_LRCK		-> I2S0_CODEC_ASP_LRCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 129 : I2S0_BCLK		-> I2S0_CODEC_ASP_BCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 130 : I2S0_DOUT		-> I2S0_CODEC_ASP_DOUT
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 131 : I2S0_DIN		-> I2S0_CODEC_ASP_DIN
	CFG_DISABLED,						// 132 : I2S1_MCK		-> NC_I2S1_MCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 133 : I2S1_LRCK		-> I2S1_CODEC_XSP_LRCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 134 : I2S1_BCLK		-> I2S1_CODEC_XSP_BCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 135 : I2S1_DOUT		-> I2S1_CODEC_XSP_DOUT

/* Port 17 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 136 : I2S1_DIN		-> I2S1_CODEC_XSP_DIN
	CFG_DISABLED,						// 137 : I2S2_LRCK		-> NC_I2S2_LRCK
	CFG_DISABLED,						// 138 : I2S2_BCLK		-> NC_I2S2_BCLK
	CFG_DISABLED,						// 139 : I2S2_DOUT		-> NC_I2S2_DOUT
	CFG_DISABLED,						// 140 : I2S2_DIN		-> NC_I2S2_DIN
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 141 : I2S3_MCK		-> BB_JTAG_TRST_L
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 142 : I2S3_LRCK		-> BB_JTAG_TDO
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 143 : I2S3_BCLK		-> BB_JTAG_TDI

/* Port 18 */
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 144 : I2S3_DOUT		-> BB_JTAG_TMS
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 145 : I2S3_DIN		-> BB_JTAG_TCK
	CFG_DISABLED,						// 146 : I2S4_MCK		-> NC_I2S4_MCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 147 : I2S4_LRCK		-> I2S4_SOC2BT_LRCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 148 : I2S4_BCLK		-> I2S4_SOC2BT_BCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 149 : I2S4_DOUT		-> I2S4_SOC2BT_DATA
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 150 : I2S4_DIN		-> I2S4_BT2SOC_DATA
	CFG_DISABLED,

/* Port 19 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 20 */
	CFG_OUT_0 | SLOW_SLEW,					// 160 : TMR32_PWM0		-> OSCAR_TIME_SYNC_HOST_INT
	CFG_DISABLED,						// 161 : TMR32_PWM1		-> NC_TMR32_PWM1
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 162 : TMR32_PWM2		-> CLK_32K_SOC2CUMULUS
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 163 : SIO_7816UART0_SDA	-> HSIC1_SOC2WLAN_HOST_RDY
	CFG_IN,							// 164 : SIO_7816UART0_SCL	-> HSIC1_WLAN2SOC_DEVICE_RDY
	CFG_IN | PULL_DOWN,					// 165 : SIO_7816UART0_RST	-> HSIC1_WLAN2SOC_REMOTE_WAKE
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 166 : SIO_7816UART1_SDA	-> HSIC2_SOC2BB_HOST_RDY
	CFG_IN | PULL_DOWN,					// 167 : SIO_7816UART1_SCL	-> HSIC2_BB2SOC_DEVICE_RDY

/* Port 21 */
	CFG_IN | PULL_DOWN,					// 168 : SIO_7816UART1_RST	-> HSIC2_BB2SOC_REMOTE_WAKE
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 169 : UART6_TXD		-> UART6_TS_ACC_TXD
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 170 : UART6_RXD		-> UART6_TS_ACC_RXD
	CFG_FUNC0 | FAST_SLEW,					// 171 : I2C3_SDA		-> I2C3_SDA_1V8
	CFG_FUNC0 | FAST_SLEW,					// 172 : I2C3_SCL		-> I2C3_SCL_1V8
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 22 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 23 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 24 */
	CFG_FUNC0 | SLOW_SLEW,					// 192 : EDP_HPD		-> EDP_HPD
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 193 : I2S0_MCK		-> I2S0_CODEC_ASP_MCK
	CFG_DISABLED,						// 194 : I2S2_MCK		-> NC_I2S2_MCK
};
#endif /* SUB_TARGET_J72 */

#ifdef SUB_TARGET_J73
#if PIN_CFG_AP
static const u_int32_t gpio_default_cfg_ap[GPIO_GROUP_COUNT * GPIOPADPINS] = {
#elif PIN_CFG_DEV
static const u_int32_t gpio_default_cfg_dev[GPIO_GROUP_COUNT * GPIOPADPINS] = {
#endif

/* Port  0 */
	CFG_DISABLED,						//   0 : TST_CLKOUT		-> SOC_TST_CLKOUT
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//   1 : WDOG			-> WDOG_SOC
	CFG_IN,							//   2 : GPIO[0]		-> GPIO_BTN_HOME_L
	CFG_IN,							//   3 : GPIO[1]		-> GPIO_BTN_ONOFF_L
	CFG_IN | PULL_UP,					//   4 : GPIO[2]		-> GPIO_BTN_VOL_DOWN_L
	CFG_IN | PULL_UP,					//   5 : GPIO[3]		-> GPIO_BTN_VOL_UP_L
	CFG_IN | PULL_UP,					//   6 : GPIO[4]		-> GPIO_CAM_ALS2SOC_IRQ_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//   7 : GPIO[5]		-> GPIO_BT_WAKE

/* Port  1 */
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//   8 : GPIO[6]		-> GPIO_SOC2BB_WAKE_MODEM
	CFG_DISABLED,						//   9 : GPIO[7]		-> NC_GPIO7
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  10 : GPIO[8]		-> GPIO_SOC2BB_RST_L
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  11 : GPIO[9]		-> GPIO_SOC2BB_RADIO_ON_L
	CFG_IN | PULL_DOWN,					//  12 : GPIO[10]		-> GPIO_BB2SOC_RESET_DET_L
	CFG_DISABLED,						//  13 : GPIO[11]		-> NC_GPIO11
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  14 : GPIO[12]		-> GPIO_SOC2OSCAR_DBGEN
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  15 : GPIO[13]		-> GPIO_SOC2GRAPE_RESET_L

/* Port  2 */
	CFG_DISABLED,						//  16 : GPIO[14]		-> NC_GPIO14
	CFG_IN,							//  17 : GPIO[15]		-> GPIO_BB2SOC_GSM_TXBURST
	CFG_DISABLED,						//  18 : GPIO[16]		-> GPIO_BOARD_ID_3
	CFG_IN,							//  19 : GPIO[17]		-> GPIO_TS2SOC2PMU_INT
	CFG_DISABLED,						//  20 : GPIO[18]		-> GPIO_BOOT_CONFIG_0
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  21 : GPIO[19]		-> GPIO_BB2SOC_GPS_SYNC
	CFG_IN,							//  22 : GPIO[20]		-> GPIO_PROX2SOC_IRQ_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  23 : GPIO[21]		-> GPIO_SOC2LCD_PWREN

/* Port  3 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  4 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  32 : UART1_TXD		-> UART1_SOC2BT_TX
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  33 : UART1_RXD		-> UART1_BT2SOC_TX
	CFG_OUT_1 | DRIVE_X2 | SLOW_SLEW,			//  34 : UART1_RTSN		-> UART1_SOC2BT_RTS_L
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  35 : UART1_CTSN		-> UART1_BT2SOC_RTS_L
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  36 : UART2_TXD		-> UART2_SOC2WLAN_TX
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  37 : UART2_RXD		-> UART2_WLAN2SOC_TX
	CFG_DISABLED,						//  38 : UART2_RTSN		-> NC_GPIO_UART2_RTSN
	CFG_DISABLED,						//  39 : UART2_CTSN		-> NC_GPIO_UART2_CTSN

/* Port  5 */
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  40 : UART3_TXD		-> UART3_SOC2BB_TX
	CFG_FUNC0 | SLOW_SLEW,					//  41 : UART3_RXD		-> UART3_BB2SOC_TX
	CFG_IN | DRIVE_X2 | SLOW_SLEW,				//  42 : UART3_RTSN		-> UART3_SOC2BB_RTS_L
	CFG_FUNC0 | SLOW_SLEW,					//  43 : UART3_CTSN		-> UART3_BB2SOC_RTS_L
	CFG_FUNC0 | AP_DEV_DRIVE_STR(X1, X2) | SLOW_SLEW,	//  44 : UART5_RTXD		-> UART5_BATT_TRXD
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  6 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  7 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port  8 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  64 : UART4_TXD		-> UART4_SOC2OSCAR_TXD
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  65 : UART4_RXD		-> UART4_OSCAR2SOC_RXD
	CFG_OUT_1 | DRIVE_X2 | SLOW_SLEW,			//  66 : UART4_RTSN		-> GPIO_OSCAR_RESET_L
	CFG_IN,							//  67 : UART4_CTSN		-> PMU_GPIO_OSCAR2PMU_HOST_WAKE
	CFG_DISABLED,						//  68 : SPI1_SCLK		-> NC_SPI1_SCLK
	CFG_DISABLED,						//  69 : SPI1_MOSI		-> NC_SPI1_MOSI
	CFG_DISABLED,						//  70 : SPI1_MISO		-> NC_SPI1_MISO
	CFG_DISABLED,						//  71 : SPI1_SSIN		-> NC_SPI1_SSIN

/* Port  9 */
	CFG_DISABLED,						//  72 : SPI0_SCLK		-> GPIO_BOARD_ID_0
	CFG_DISABLED,						//  73 : SPI0_MOSI		-> GPIO_BOARD_ID_1
	CFG_DISABLED,						//  74 : SPI0_MISO		-> GPIO_BOARD_ID_2
	CFG_DISABLED,						//  75 : SPI0_SSIN		-> NC_SPI0_SSIN
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  76 : SPI2_SCLK		-> SPI2_GRAPE_SCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  77 : SPI2_MOSI		-> SPI2_GRAPE_MOSI
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  78 : SPI2_MISO		-> SPI2_GRAPE_MISO
	CFG_OUT_1 | AP_DEV_DRIVE_STR(X1, X2) | SLOW_SLEW,	//  79 : SPI2_SSIN		-> SPI2_GRAPE_CS_L

/* Port 10 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  80 : I2C0_SDA		-> I2C0_SDA_1V8
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  81 : I2C0_SCL		-> I2C0_SCL_1V8
	CFG_DISABLED,						//  82 : I2C1_SDA		-> I2C1_SOC2OSCAR_SWDIO_1V8
	CFG_DISABLED,						//  83 : I2C1_SCL		-> I2C1_SOC2OSCAR_SWDCLK_1V8
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  84 : ISP0_SDA		-> ISP0_CAM_REAR_SDA
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  85 : ISP0_SCL		-> ISP0_CAM_REAR_SCL
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  86 : ISP1_SDA		-> ISP1_CAM_FRONT_SDA
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  87 : ISP1_SCL		-> ISP1_CAM_FRONT_SCL

/* Port 11 */
	CFG_OUT_0 | PULL_DOWN | DRIVE_X2 | SLOW_SLEW,		//  88 : SENSOR0_RST		-> ISP0_CAM_REAR_SHUTDOWN_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  89 : SENSOR0_CLK		-> ISP0_CAM_REAR_CLK_R
	CFG_DISABLED,						//  90 : SENSOR0_XSHUTDOWN	-> NC_SENSOR0_XSHUTDOWN
	CFG_DISABLED,						//  91 : SENSOR0_ISTRB		-> BB_IPC_GPIO
	CFG_OUT_0 | PULL_DOWN | DRIVE_X2 | SLOW_SLEW,		//  92 : SENSOR1_RST		-> ISP1_CAM_FRONT_SHUTDOWN_L
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  93 : SENSOR1_CLK		-> ISP1_CAM_FRONT_CLK_R
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			//  94 : SENSOR1_XSHUTDOWN	-> AUD_SPKRAMP_MUTE_L
	CFG_DISABLED,						//  95 : SENSOR1_ISTRB		-> NC_SENSOR1_ISTRB

/* Port 12 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  96 : SPI3_MOSI		-> SPI3_CODEC_MOSI
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  97 : SPI3_MISO		-> SPI3_CODEC_MISO
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			//  98 : SPI3_SCLK		-> SPI3_CODEC_SCLK
	CFG_OUT_1 | DRIVE_X2 | SLOW_SLEW,			//  99 : SPI3_SSIN		-> SPI3_CODEC_CS_L
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 100 : I2C2_SDA		-> I2C2_SDA_1V8
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 101 : I2C2_SCL		-> I2C2_SCL_1V8
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 102 : GPIO[22]		-> GPIO_SOC2PMU_KEEPACT
	CFG_IN | PULL_UP,					// 103 : GPIO[23]		-> GPIO_PMU2SOC_IRQ_L

/* Port 13 */
	CFG_IN | PULL_UP,					// 104 : GPIO[24]		-> GPIO_CODEC2SOC_IRQ_L
	CFG_DISABLED,						// 105 : GPIO[25]		-> GPIO_BOOT_CONFIG_1
	CFG_IN,							// 106 : GPIO[26]		-> GPIO_FORCE_DFU
	CFG_OUT_0 | SLOW_SLEW,					// 107 : GPIO[27]		-> TP_GPIO_DFU_STATUS
	CFG_DISABLED,						// 108 : GPIO[28]		-> GPIO_BOOT_CONFIG_2
	CFG_DISABLED,						// 109 : GPIO[29]		-> GPIO_BOOT_CONFIG_3
	CFG_IN,							// 110 : GPIO[30]		-> GPIO_BTN_SRL_L
	CFG_IN | PULL_UP,					// 111 : GPIO[31]		-> GPIO_GRAPE2SOC_IRQ_L

/* Port 14 */
	CFG_DISABLED,						// 112 : GPIO[32]		-> NC_GPIO32
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 113 : GPIO[33]		-> GPIO_HS3_SHUNT_EN
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 114 : GPIO[34]		-> GPIO_HS4_SHUNT_EN
	CFG_DISABLED,						// 115 : GPIO[35]		-> GPIO_BRD_REV3
	CFG_DISABLED,						// 116 : GPIO[36]		-> GPIO_BRD_REV2
	CFG_DISABLED,						// 117 : GPIO[37]		-> GPIO_BRD_REV1
	CFG_DISABLED,						// 118 : GPIO[38]		-> GPIO_BRD_REV0
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 119 : DISP_VSYNC		-> DISPLAY_SYNC

/* Port 15 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 120 : SOCHOT0		-> SOCHOT0_L
	CFG_FUNC0 | DRIVE_X2,					// 121 : SOCHOT1		-> SOCHOT1_L
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 122 : UART0_TXD		-> UART0_SOC_TXD
	CFG_FUNC0 | PULL_UP | SLOW_SLEW,			// 123 : UART0_RXD		-> UART0_SOC_RXD
	CFG_FUNC0 | SLOW_SLEW,					// 124 : DWI_DI			-> SOC_TST_CPUSWITCH_OUT
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 125 : DWI_DO			-> DWI_AP_DO
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 126 : DWI_CLK		-> DWI_AP_CLK
	CFG_DISABLED,						// 127 : UNSPECIFIED		-> UNSPECIFIED

/* Port 16 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 128 : I2S0_LRCK		-> I2S0_CODEC_ASP_LRCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 129 : I2S0_BCLK		-> I2S0_CODEC_ASP_BCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 130 : I2S0_DOUT		-> I2S0_CODEC_ASP_DOUT
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 131 : I2S0_DIN		-> I2S0_CODEC_ASP_DIN
	CFG_DISABLED,						// 132 : I2S1_MCK		-> NC_I2S1_MCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 133 : I2S1_LRCK		-> I2S1_CODEC_XSP_LRCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 134 : I2S1_BCLK		-> I2S1_CODEC_XSP_BCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 135 : I2S1_DOUT		-> I2S1_CODEC_XSP_DOUT

/* Port 17 */
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 136 : I2S1_DIN		-> I2S1_CODEC_XSP_DIN
	CFG_DISABLED,						// 137 : I2S2_LRCK		-> NC_I2S2_LRCK
	CFG_DISABLED,						// 138 : I2S2_BCLK		-> NC_I2S2_BCLK
	CFG_DISABLED,						// 139 : I2S2_DOUT		-> NC_I2S2_DOUT
	CFG_DISABLED,						// 140 : I2S2_DIN		-> NC_I2S2_DIN
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 141 : I2S3_MCK		-> BB_JTAG_TRST_L
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 142 : I2S3_LRCK		-> BB_JTAG_TDO
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 143 : I2S3_BCLK		-> BB_JTAG_TDI

/* Port 18 */
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 144 : I2S3_DOUT		-> BB_JTAG_TMS
	CFG_DISABLED | DRIVE_X2 | SLOW_SLEW,			// 145 : I2S3_DIN		-> BB_JTAG_TCK
	CFG_DISABLED,						// 146 : I2S4_MCK		-> NC_I2S4_MCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 147 : I2S4_LRCK		-> I2S4_SOC2BT_LRCK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 148 : I2S4_BCLK		-> I2S4_SOC2BT_BCLK
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 149 : I2S4_DOUT		-> I2S4_SOC2BT_DATA
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 150 : I2S4_DIN		-> I2S4_BT2SOC_DATA
	CFG_DISABLED,

/* Port 19 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 20 */
	CFG_OUT_0 | SLOW_SLEW,					// 160 : TMR32_PWM0		-> OSCAR_TIME_SYNC_HOST_INT
	CFG_DISABLED,						// 161 : TMR32_PWM1		-> NC_TMR32_PWM1
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 162 : TMR32_PWM2		-> CLK_32K_SOC2CUMULUS
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 163 : SIO_7816UART0_SDA	-> HSIC1_SOC2WLAN_HOST_RDY
	CFG_IN,							// 164 : SIO_7816UART0_SCL	-> HSIC1_WLAN2SOC_DEVICE_RDY
	CFG_IN | PULL_DOWN,					// 165 : SIO_7816UART0_RST	-> HSIC1_WLAN2SOC_REMOTE_WAKE
	CFG_OUT_0 | DRIVE_X2 | SLOW_SLEW,			// 166 : SIO_7816UART1_SDA	-> HSIC2_SOC2BB_HOST_RDY
	CFG_IN | PULL_DOWN,					// 167 : SIO_7816UART1_SCL	-> HSIC2_BB2SOC_DEVICE_RDY

/* Port 21 */
	CFG_IN | PULL_DOWN,					// 168 : SIO_7816UART1_RST	-> HSIC2_BB2SOC_REMOTE_WAKE
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 169 : UART6_TXD		-> UART6_TS_ACC_TXD
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 170 : UART6_RXD		-> UART6_TS_ACC_RXD
	CFG_FUNC0 | FAST_SLEW,					// 171 : I2C3_SDA		-> I2C3_SDA_1V8
	CFG_FUNC0 | FAST_SLEW,					// 172 : I2C3_SCL		-> I2C3_SCL_1V8
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 22 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 23 */
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,
	CFG_DISABLED,

/* Port 24 */
	CFG_FUNC0 | SLOW_SLEW,					// 192 : EDP_HPD		-> EDP_HPD
	CFG_FUNC0 | DRIVE_X2 | SLOW_SLEW,			// 193 : I2S0_MCK		-> I2S0_CODEC_ASP_MCK
	CFG_DISABLED,						// 194 : I2S2_MCK		-> NC_I2S2_MCK
};
#endif /* SUB_TARGET_J73 */

#undef AP_DEV_DRIVE_STR
